#==============================================================================
#
#  $Id$
#
"""
    Utilities used in more than one test script.
"""
#
#  Copyright (C) 2006 Michael A. Muller
#
#  Permission is granted to use, modify and redistribute this code,
#  providing that the following conditions are met:
#
#  1) This copyright/licensing notice must remain intact.
#  2) If the code is modified and redistributed, the modifications must 
#  include documentation indicating that the code has been modified.
#  3) The author(s) of this code must be indemnified and held harmless
#  against any damage resulting from the use of this code.
#
#  This code comes with ABSOLUTELY NO WARRANTEE, not even the implied 
#  warrantee of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  
#
#==============================================================================

class SortedList(list):
    """
        A sorted list of key-value pairs - useful for keeping track of the 
        contents of a b-tree.
    """
   
    def __bsearch(self, key, start, end):
        """
            Binary search a range of the list for the given key.  Returns the 
            index of where the key belongs.
        """
        if start == end:
            return start
        
        mid = start + (end - start) / 2
        if key > self[mid][0]:
            return self.__bsearch(key, mid + 1, end)
        else:
            return self.__bsearch(key, start, mid)
       
    def add(self, key, val):
        i = self.__bsearch(key, 0, len(self))
        self.insert(i, (key, val))
    
    def remove(self, key):
        i = self.__bsearch(key, 0, len(self))
        if self[i][0] == key:
            del self[i]
        else:
            raise KeyError(key)

